#include <stdafx.h>
#include "ZeoScriptEx.h"

#include <Zeolite.h>

#include <zFunc.h>
#include <zList.h>
#include <zStr.h>

static ZFUNC hfRunScript2 = NULL;

bool zs_Execute(const char* lpScript, ZLIST hScriptOptions, ZVAR* ppRval) {

	CzFunc fRunScript2;
	if(!hfRunScript2) {
		if(!fRunScript2.GetFunc("ZeoScript.RunScript2")) {
			zeoReportError("zs_Execute error:\r\n - cannot retrieve 'RunScript2' function");
			return false;
		}
		hfRunScript2 = fRunScript2.GetZVAR();
	} else {
		if(!fRunScript2.Attach(hfRunScript2)) {
			zeoReportError("zs_Execute error:\r\n - cannot attach to 'RunScript2' function");
			return false;
		}
	}

	if(ppRval) {
		if(! (*ppRval)) {
			// if user wants the rval, they need to provide a real handle.
			// this is because the CzFunc will go out of scope and take its rval with it at the end of
			// this func, so it's dangerous to return a handle to that local instance.

			zeoReportError("zs_Execute error:\r\n - ppRval points to NULL handle for return value");
			return false;
		}
	}

	if(!zstr_SetText(fRunScript2.GetArgI(0), lpScript)) {
		zeoReportError("zs_Execute error:\r\n - cannot set arg0");
		return false;
	}
	if(!fRunScript2.SetArgValueI(1, VarID_hvar, &hScriptOptions)) {
		zeoReportError("zs_Execute error:\r\n - cannot set arg1");
		return false;
	}

	if(!fRunScript2.Execute2(NULL, ppRval)) {
		zeoWriteToLog("zs_Execute error:\r\n - script execution failed");
		return false;
	}

	return true;
}