#include <Zeolite.h>
#include "zApp.h"
#include <zClasses.h>
#include <zFunc.h>

bool zapp_GetTempDir(CzStr& TempDir) {
	if(!zscript_Execute("zs", "application.GetTempDir", (ZVAR)TempDir)) { 
		zeoReportError("zapp_GetTempDir error:\r\n - call to application.GetTempDir failed");
		return false;
	}
	return true;
}
long zapp_GetUID() {
	CzVar v;
	v.Create(VarID_int);
	if(!zscript_Execute("zs", "application.GetUID", (ZVAR)v)) { 
		zeoReportError("zapp_GetUID error:\r\n - call to application.GetUID failed");
		return -1;
	}
	int i = 0;
	if(!v.GetValue(VarID_int, &i)) {
		return -1;
	}
	return i;
}

HICON zapp_GetIcon() {

	CzFunc f;
	if(!f.GetFunc("application.GetIcon")) {
		return NULL;
	}

	if(!f.Execute2()) {
		return NULL;
	}
	
	HICON hIcon = NULL;
	if(!f.m_rval.GetValue(VarID_voidptr, &hIcon)) {
		return NULL;
	}

	return hIcon;
}
HWND zapp_GetMainHWND() {

	CzFunc f;
	if(!f.GetFunc("application.GetMainHWND")) {
		zeoReportError("zapp_GetMainHWND error:\r\n - cannot get function");
		return NULL;
	}

	if(!f.Execute2()) {
		zeoReportError("zapp_GetMainHWND error:\r\n - call to application.GetMainHWND failed");
		return NULL;
	}
	
	HWND hWnd = NULL;
	if(!f.m_rval.GetValue(VarID_voidptr, &hWnd)) {
		zeoReportError("zapp_GetMainHWND error:\r\n - cannot set rval");
		return NULL;
	}

	return hWnd;
}

bool zapp_GetPath(const char* lpPathName, CzStr& rval) {

	CzFunc f;
	if(!f.GetFunc("application.GetPath")) {
		zeoReportError("zapp_GetPath error:\r\n - cannot get function");
		return false;
	}
	if(!zstr_SetText(f.GetArgI(0), lpPathName)) {
		zeoReportError("zapp_GetPath error:\r\n - cannot set path name string");
		return false;
	}
	if(!f.Execute2()) {
		zeoReportError("zapp_GetPath error:\r\n - call to application.GetPath failed");
		return false;
	}
	if(!rval.CopyValue(f.m_rval)) {
		zeoReportError("zapp_GetPath error:\r\n - cannot copy rval");
		return false;
	}

	if(!rval.GetLength()) {
		// null string, indicates failure
		zeoReportError("zapp_GetPath error:\r\n - application.GetPath function returned no string");
		return false;
	}

	return true;
}