#include <Zeolite.h>
#include "zBackup.h"
#include <zClasses.h>
#include <zFunc.h>

bool zbackup_Undo() {
	
	CzFunc f;
	if(!f.GetFunc("L3DTio_Backup.Undo")) {
		zeoReportError("zbackup_Undo error:\r\n - cannot get function");
		return false;
	}

	if(!f.Execute2()) {
		zeoWriteToLog("zbackup_Undo error:\r\n - function call failed"); // silently
		return false;
	}

	/* ext func has no rval
	bool rval = false;
	if(!f.m_rval.GetValue(VarID_bool, &rval)) {
		zeoReportError("zbackup_Undo error:\r\n - cannot get rval");
		return false;
	}

	return rval;
	*/

	return true;
}
bool zbackup_Restore() {
	
	CzFunc f;
	if(!f.GetFunc("L3DTio_Backup.Restore")) {
		zeoReportError("zbackup_Restore error:\r\n - cannot get function");
		return false;
	}

	if(!f.Execute2()) {
		zeoWriteToLog("zbackup_Restore error:\r\n - function call failed"); // silently
		return false;
	}

	bool rval = false;
	if(!f.m_rval.GetValue(VarID_bool, &rval)) {
		zeoReportError("zbackup_Restore error:\r\n - cannot get rval");
		return false;
	}

	return rval;
}

long zbackup_nRecords() {

	CzFunc f;
	if(!f.GetFunc("L3DTio_Backup.GetRecordCount")) {
		zeoReportError("zbackup_nRecords error:\r\n - cannot get function");
		return 0;
	}

	if(!f.Execute2()) {
		zeoWriteToLog("zbackup_nRecords error:\r\n - function call failed"); // silently
		return 0;
	}

	long rval = 0;
	if(!f.m_rval.GetValue(VarID_int, &rval)) {
		zeoReportError("zbackup_Getzbackup_nRecordsRecordCount error:\r\n - cannot get rval");
		return 0;
	}

	return rval;
}


bool zbackup_BackupMaps(const char* lpMapNames, const char* lpRecordName, unsigned long Flags, const char* lpRestoreScript) {

	CzFunc f;
	if(!f.GetFunc("L3DTio_Backup.BackupMapList2")) {
		zeoReportError("zbackup_BackupMaps error:\r\n - cannot get function");
		return false;
	}

	int argid = 0;

	zstr_SetText(f.GetArgI(argid++), lpMapNames);
	zstr_SetText(f.GetArgI(argid++), lpRecordName);
	f.SetArgValueI(argid++, VarID_uint, &Flags);
	zstr_SetText(f.GetArgI(argid++), lpRestoreScript);

	if(!f.Execute2()) {
		zeoWriteToLog("zbackup_BackupMaps error:\r\n - function call failed"); // silently
		return false;
	}

	bool rval = false;
	if(!f.m_rval.GetValue(VarID_bool, &rval)) {
		zeoReportError("zbackup_BackupMaps error:\r\n - cannot get rval");
		return false;
	}

	return rval;
}

bool zbackup_BackupMapArea(const char* lpMapName, long x0, long y0, long cx, long cy, const char* lpRecordName, unsigned long Flags, const char* lpRestoreScript) {
	CzFunc f;
	if(!f.GetFunc("L3DTio_Backup.BackupMapArea")) {
		zeoReportError("zbackup_BackupMapArea error:\r\n - cannot get function");
		return false;
	}

	int argid = 0;

	zstr_SetText(f.GetArgI(argid++), lpMapName);
	f.SetArgValueI(argid++, VarID_int, &x0);
	f.SetArgValueI(argid++, VarID_int, &y0);
	f.SetArgValueI(argid++, VarID_int, &cx);
	f.SetArgValueI(argid++, VarID_int, &cy);
	zstr_SetText(f.GetArgI(argid++), lpRecordName);
	f.SetArgValueI(argid++, VarID_uint, &Flags);
	zstr_SetText(f.GetArgI(argid++), lpRestoreScript);

	if(!f.Execute2()) {
		zeoWriteToLog("zbackup_BackupMapArea error:\r\n - function call failed"); // silently
		return false;
	}

	bool rval = false;
	if(!f.m_rval.GetValue(VarID_bool, &rval)) {
		zeoReportError("zbackup_BackupMapArea error:\r\n - cannot get rval");
		return false;
	}

	return rval;
}

bool zbackup_GetAutoBackupFlag() {

	CzFunc f;
	if(!f.GetFunc("L3DTio_Backup.GetAutoBackupFlag")) {
		zeoReportError("zbackup_GetAutoBackupFlag error:\r\n - cannot get function");
		return false;
	}

	if(!f.Execute2()) {
		zeoWriteToLog("zbackup_GetAutoBackupFlag error:\r\n - function call failed"); // silently
		return false;
	}

	bool rval = false;
	if(!f.m_rval.GetValue(VarID_bool, &rval)) {
		zeoReportError("zbackup_GetAutoBackupFlag error:\r\n - cannot get rval");
		return false;
	}

	return rval;
}

//
// edit record functions
//

bool zbackup_EditRecord_Init(const char* lpRecordName, const char* lpMapNames, int EditMaskRes, unsigned long Flags, const char* lpRestoreScript) {

	CzFunc f;
	if(!f.GetFunc("L3DTio_Backup.EditRecord.Init")) {
		zeoReportError("zbackup_EditRecord_Init error:\r\n - cannot get function");
		return false;
	}

	int argid = 0;

	zstr_SetText(f.GetArgI(argid++), lpRecordName);
	zstr_SetText(f.GetArgI(argid++), lpMapNames);
	f.SetArgValueI(argid++, VarID_int, &EditMaskRes);
	f.SetArgValueI(argid++, VarID_uint, &Flags);
	zstr_SetText(f.GetArgI(argid++), lpRestoreScript);

	if(!f.Execute2()) {
		zeoWriteToLog("zbackup_EditRecord_Init error:\r\n - function call failed"); // silently
		return false;
	}

	bool rval = false;
	if(!f.m_rval.GetValue(VarID_bool, &rval)) {
		zeoReportError("zbackup_EditRecord_Init error:\r\n - cannot get rval");
		return false;
	}

	if(!rval) {
		zeoReportError("zbackup_EditRecord_Init error:\r\n - call to 'L3DTio_Backup.EditRecord.Init' failed");
		return false;
	}

	return rval;
}


bool zbackup_EditRecord_AddMapArea(int x1, int y1, int x2, int y2) {
	CzFunc f;
	if(!f.GetFunc("L3DTio_Backup.EditRecord.AddMapArea")) {
		zeoReportError("zbackup_EditRecord_AddMapArea error:\r\n - cannot get function");
		return false;
	}

	int argid = 0;

	f.SetArgValueI(argid++, VarID_int, &x1);
	f.SetArgValueI(argid++, VarID_int, &y1);
	f.SetArgValueI(argid++, VarID_int, &x2);
	f.SetArgValueI(argid++, VarID_int, &y2);

	if(!f.Execute2()) {
		zeoWriteToLog("zbackup_EditRecord_AddMapArea error:\r\n - function call failed"); // silently
		return false;
	}

	bool rval = false;
	if(!f.m_rval.GetValue(VarID_bool, &rval)) {
		zeoReportError("zbackup_EditRecord_AddMapArea error:\r\n - cannot get rval");
		return false;
	}

	return rval;
}

bool zbackup_EditRecord_Finalise() {

	CzFunc f;
	if(!f.GetFunc("L3DTio_Backup.EditRecord.Finalise")) {
		zeoReportError("zbackup_EditRecord_Finalise error:\r\n - cannot get function");
		return false;
	}

	if(!f.Execute2()) {
		zeoWriteToLog("zbackup_EditRecord_Finalise error:\r\n - function call failed"); // silently
		return false;
	}

	bool rval = false;
	if(!f.m_rval.GetValue(VarID_bool, &rval)) {
		zeoReportError("zbackup_EditRecord_Finalise error:\r\n - cannot get rval");
		return false;
	}

	return rval;
}