#include "Zeolite.h"
#include "zcombosel.h"

CzComboSel::CzComboSel(void) {
	Create();
}
CzComboSel::CzComboSel(ZVAR hComboSel) {
	Attach(hComboSel);
}

CzComboSel::~CzComboSel(void) {
}

bool CzComboSel::Create() {
	return CzVar::Create(VarID_combosel);
}
bool CzComboSel::CreateShared(const char* lpVarName) {
	return CzVar::CreateShared(VarID_combosel, lpVarName);
}

bool CzComboSel::Init(const char* lpOptionsStr, const char* lpCurSelStr, unsigned long Flags) {

	if(!m_hVar)	return false;

	return zcombosel_Init(m_hVar, lpOptionsStr, lpCurSelStr, Flags);
}

long CzComboSel::nOptions() {
	if(!m_hVar)	return 0;

	return zcombosel_nOptions(m_hVar);
}
bool CzComboSel::SetOptionsA(const char* lpOptionsStr) {
	if(!m_hVar)	return false;

	return zcombosel_SetOptionsA(m_hVar, lpOptionsStr);
}
bool CzComboSel::GetOptionsA(ZSTR hReturnStr) {
	if(!m_hVar)	return false;

	return zcombosel_GetOptionsA(m_hVar, hReturnStr);
}
bool CzComboSel::GetOptionText(long index, ZSTR hReturnStr) {
	if(!m_hVar)	return false;

	return zcombosel_GetOptionText(m_hVar, index, hReturnStr);
}

long CzComboSel::AddOptionA(const char* lpOptionStr) {
	if(!m_hVar)	return -1;

	return zcombosel_AddOptionA(m_hVar, lpOptionStr);
}

long CzComboSel::FindOptionA(const char* lpOptionStr) {
	if(!m_hVar)	return -1;

	return zcombosel_FindOptionA(m_hVar, lpOptionStr);
}
long CzComboSel::FindNextSelItem(long StartAt) {

	if(!m_hVar)	return -1;

	// handle trivial case of single selection
	if(! (GetFlags() & ZCOMBOSEL_MULTISEL) ) {
		int CurSel = GetCurSelI();
		if(CurSel<=StartAt)	return CurSel;
		
		// CurSel was not at or after StartAt, so return failure
		return -1;
	}

	// handle multisel
	for(int i=StartAt; i<nOptions(); i++) {
		if(GetSelI(i)) {
			return i;
		}

	}

	return -1;
}

//
// single selection
//

bool CzComboSel::SetCurSelI(long CurSelID) {
	if(!m_hVar)	return false;

	return zcombosel_SetCurSelI(m_hVar, CurSelID);
}
bool CzComboSel::SetCurSelA(const char* lpCurSelStr) {
	if(!m_hVar)	return false;

	return zcombosel_SetCurSelA(m_hVar, lpCurSelStr);
}
long CzComboSel::GetCurSelI() {
	if(!m_hVar)	return -1;

	return zcombosel_GetCurSelI(m_hVar);
}
bool CzComboSel::GetCurSelA(ZSTR hReturnStr) {
	if(!m_hVar)	return false;

	return zcombosel_GetCurSelA(m_hVar, hReturnStr);
}

// multi selection
bool CzComboSel::SetSelI(long index, bool State) {
	if(!m_hVar)	return false;

	return zcombosel_SetSelI(m_hVar, index, State);
}
bool CzComboSel::SetSelA(const char* lpOptionStr, bool State) {
	if(!m_hVar)	return false;

	return zcombosel_SetSelA(m_hVar, lpOptionStr, State);
}
bool CzComboSel::GetSelI(long index) {
	if(!m_hVar)	return false;

	return zcombosel_GetSelI(m_hVar, index);
}
bool CzComboSel::GetSelA(const char* lpOptionStr) {
	if(!m_hVar)	return false;

	return zcombosel_GetSelA(m_hVar, lpOptionStr);
}

unsigned long CzComboSel::GetFlags() {
	if(!m_hVar)	return 0;

	return zcombosel_GetFlags(m_hVar);
}