#pragma once
#include "zvar.h"

class CzList :
	public CzVar
{
public:
	CzList(void);
	CzList(ZLIST hList);
	~CzList(void);

	bool Create();
	bool CreateShared(const char* lpVarName);

	long nItems();
	ZVAR CreateItem(long VarID, const char* lpVarName);
	ZVAR GetOrCreateItem(long VarID, const char* lpVarName);
	
	ZVAR GetItem(long index);
	ZVAR GetItem(const char* lpVarName);
	ZVAR GetItemI(long index);
	ZVAR GetItemA(const char* lpVarName);

	bool DelItem(long index);
	bool DelItem(const char* lpVarName);
	bool DelItemI(long index);
	bool DelItemA(const char* lpVarName);
	bool DelAll();

	bool Append(ZLIST hList);

	bool GetItemValue(const char* lpItemName, long VarID, void* pValue);
	bool GetItemValue(long index, long VarID, void* pValue);
	bool GetItemValueI(long index, long VarID, void* pValue);
	bool GetItemValueA(const char* lpItemName, long VarID, void* pValue);

	bool SetItemValue(const char* lpItemName, long VarID, void* pValue);
	bool SetItemValue(long index, long VarID, void* pValue);
	bool SetItemValueI(long index, long VarID, void* pValue);
	bool SetItemValueA(const char* lpItemName, long VarID, void* pValue);

	const char* GetItemName(long index);

	bool ItemExists(const char* lpItemName);
	long FindItemA(const char* lpItemName, long StartAt = 0);
	long FindItemH(ZVAR hItem, long StartAt = 0);

	bool Sort(long From, long To);
	bool Sort(const char* lpItemName, long To);
};
