#include "Zeolite.h"
#include "zmaterial.h"
#include "zfunc.h"
#include "zstr.h"

static CzFunc* pzfGetMaterialA = NULL;
static CzFunc* pzfGetName = NULL;
static CzFunc* pzfGetString = NULL;
static CzFunc* pzfGetParamI = NULL;
static CzFunc* pzfGetParamF = NULL;

CzMaterial::CzMaterial(void) {
}

CzMaterial::~CzMaterial(void) {
}

bool CzMaterial::Attach(ZVAR hVar) {

	if(VarID_material!=zvar_GetTypeID(hVar)) {
		zeoReportError("CzMaterial::Attach error:\r\n - no material var attached");
		return false;
	}

	// now finally attach to var
	if(!CzVar::Attach(hVar)) {
		zeoReportError("CzMaterial::Attach error:\r\n - call to CzVar::Attach failed");
		return false;
	}

	return true;
}


bool CzMaterial::GetMaterialA(const char* lpMaterialName) {
	if(NULL==pzfGetMaterialA) {
		pzfGetMaterialA = new CzFunc;
		if(!pzfGetMaterialA->GetFunc("material.GetMaterialA")) {
			zeoReportError("CzMaterial::GetMaterialA error:\r\n - cannot get zeofunc");
			return false;
		}
	}

	if(!zstr_SetText(pzfGetMaterialA->GetArgI(0), lpMaterialName)) {
		zeoReportError("CzMaterial::GetMaterialA error:\r\n - cannot set arg0");
		return false;
	}

	if(!pzfGetMaterialA->Execute2(NULL, NULL)) {
		zeoReportError("CzMaterial::GetMaterialA error:\r\n - call to CzFunc::Execute failed");
		return false;
	}

	ZVAR hVar = NULL;
	if(!pzfGetMaterialA->m_rval.GetValue(VarID_hvar, &hVar)) {
		zeoReportError("CzMaterial::GetMaterialA error:\r\n - cannot get rval");
		return false;
	}

	if(!Attach(hVar)) {
		zeoReportError("CzMaterial::GetMaterialA error:\r\n - call to CzMaterial::Attach failed");
		return false;
	}

	return true;
}


bool CzMaterial::GetMaterialName(ZSTR hNameVar) {
	return true;
}

bool CzMaterial::GetString(	const char* lpParamName, ZVAR hRval) {
	if(NULL==pzfGetString) {
		pzfGetString = new CzFunc;
		if(!pzfGetString->GetFunc("material.GetString")) {
			zeoReportError("CzMaterial::GetString error:\r\n - cannot get zeofunc");
			return false;
		}
	}

	if(!pzfGetString->SetArgValueI(0, VarID_hvar, &m_hVar)) {
		zeoReportError("CzMaterial::GetString error:\r\n - cannot set arg0");
		return false;
	}

	if(!zstr_SetText(pzfGetString->GetArgI(1), lpParamName)) {
		zeoReportError("CzMaterial::GetString error:\r\n - cannot set arg1");
		return false;
	}

	if(!pzfGetString->Execute2(NULL, NULL)) {
		zeoReportError("CzMaterial::GetString error:\r\n - call to CzFunc::Execute failed");
		return false;
	}

	if(!zvar_CopyValue(hRval, pzfGetString->m_rval)) {
		zeoReportError("CzMaterial::GetString error:\r\n - cannot copy rval");
		return false;
	}

	return true;
}
bool CzMaterial::GetParamI(const char* lpParamName, int& rval) {
	return true;
}
bool CzMaterial::GetParamF(const char* lpParamName, float& rval) {
	return true;
}
