#ifndef __ZMESH_IO_DEFINED__
#define __ZMESH_IO_DEFINED__

#pragma once

#include <stdafx.h>
#include "zmesh.h"

class CzMesh;

bool zmesh_Load(CzMesh* pMesh, const char* lpMeshFile, unsigned long Flags = NULL, ZLIST hOptions = NULL);
bool zmesh_Save(CzMesh* pMesh, const char* lpMeshFile, unsigned long Flags = NULL, ZLIST hOptions = NULL);

bool zmesh_LoadZMESH(CzMesh* pMesh, const char* lpMeshFile, unsigned long Flags = NULL, ZLIST hOptions = NULL);
bool zmesh_LoadOBJ(CzMesh* pMesh, const char* lpMeshFile, unsigned long Flags = NULL, ZLIST hOptions = NULL);
bool zmesh_LoadS3O(CzMesh* pMesh, const char* lpMeshFile, unsigned long Flags = NULL, ZLIST hOptions = NULL);

bool zmesh_SaveZMESH(CzMesh* pMesh, const char* lpMeshFile, unsigned long Flags = NULL, ZLIST hOptions = NULL);
bool zmesh_SaveOBJ(CzMesh* pMesh, const char* lpMeshFile, unsigned long Flags = NULL, ZLIST hOptions = NULL);
bool zmesh_Save3DS(CzMesh* pMesh, const char* lpMeshFile, unsigned long Flags = NULL, ZLIST hOptions = NULL);
bool zmesh_SaveX(CzMesh* pMesh, const char* lpMeshFile, unsigned long Flags = NULL, ZLIST hOptions = NULL);
bool zmesh_SaveDAE(CzMesh* pMesh, const char* lpMeshFile, unsigned long Flags = NULL, ZLIST hOptions = NULL);


// processing material paths

bool zmesh_LoadMaterialPaths(CzMesh* pMesh, const char* lpDirName); // converts path names to images in materials from relative to absolute paths after loading
bool zmesh_SaveMaterialPaths(CzMesh* pMesh, const char* lpDirName, bool CopyImages);  // converts path names to images in materials from absolute to relative paths before saving

#endif