#ifndef __ZVIEW_INCLUDED__
#define __ZVIEW_INCLUDED__

#pragma once

#include <Zeolite.h>

// mouse modes

#define MouseMode_Normal	0
#define MouseMode_Zoom		1
#define MouseMode_Ruler		2
#define MouseMode_Select	3 
#define MouseMode_DrawDM	4
#define MouseMode_DrawAM	5
#define MouseMode_DrawTX	6
#define MouseMode_DrawBYTE	7
#define MouseMode_DrawRGB	8
#define MouseMode_DrawRGBA	9
#define MouseMode_FloodWM	10
#define MouseMode_DeleteWB	11
#define MouseMode_DrawIndex	12


bool zview_ShowMap(const char* lpMapName);
bool zview_Refresh(bool RedrawBuffer);

ZMAP zview_GetActiveMap();

bool zview_GetSelectedArea(ZSTR hMapName, LPRECT lpRect);
bool zview_SetSelectedArea(const char* lpMapName, LPRECT lpRect);

bool zview_SetMouseMode(long mode);

long zview_GetBrushRadius();
bool zview_SetBrushRadius(long radius);

void zview_EnableDraw(bool EnableFlag);

#endif