#pragma once
#include "zeolite.h"

#include "zMap.h"

class CzMap;

class CzMapTile
{
public:
	CzMapTile(void);
	~CzMapTile(void);

	bool	GetMapTile(ZMAP hMap, long ti, long tj);
	bool	Attach(void* pTile, ZMAP hMap);
	void	Release();

	bool	GetPixel(long x, long y, void* pValue);
	bool	SetPixel(long x, long y, void* pValue);

	void*	GetScanlinePtr(long j);

	bool	MarkChanged(); // tile will be saved when released (or some time thereafter)

	// direct interface
	void*	GetAt(long x, long y);
	bool	IsContiguous();
	bool	MakeContiguous();
	bool	AsContiguousMap(CzMap& TileMap);
	bool	OpenDirectInterface();
	void	CloseDirectInterface();

protected:

	// direct interface variables
	void*	m_pTile;
	ZMAP	m_hMap;
	bool	m_DirectInterfaceFlag;
	long	m_TileSize;
	long	m_PixelMemSize;
	void*	m_pMem;
	bool	m_Contiguous;

};
