#pragma once

#include "Zeolite_defines.h"

class CzVar
{
public:

	CzVar(void);
	CzVar(ZVAR hVar);
	CzVar(long VarID, const char* lpVarName = 0);
	~CzVar(void);

	virtual bool Attach(ZVAR hVar);
	ZVAR GetZVAR();

	bool Create(long VarID);
	bool CreateShared(long VarID, const char* lpVarName);

	bool GetSharedVar(const char* lpVarName);
	
	virtual bool Delete();
	virtual void Release();

	const char* GetName();
	bool Rename(const char* lpNewName);

	long GetTypeID();
	bool GetTypeName(ZSTR hTypeName);
	bool IsType(long VarID);
	bool ReInit(long VarID);

	bool GetValue(long VarID, void* pValue);
	bool SetValue(long VarID, void* pValue);
	bool GetValueText(ZSTR hStrVar);
	bool SetValueText(const char* lpValueText);

	bool CopyValue(ZVAR hVarSrc);

	void* GetDataPtr(long VarID);
	
	bool SetVarRef(ZVAR hSrcVar);
	
	bool EditUI(const char* lpPrompt = NULL, unsigned long Flags = 0, ZLIST hOptions = NULL);

	//Cast-to-ZVAR operator
	operator ZVAR () {
		return GetZVAR();
	}

protected:

	ZVAR m_hVar;
	bool m_AutoDelete;
};
